#!/usr/bin/env node
// Import discord.js module
const Discord = require('discord.js')
const lib = require('./lib.js')
// create new discord client
const client = new Discord.Client({partials: ['MESSAGE', 'CHANNEL', 'REACTION']})

// On client ready announce status
client.on('ready', () => {
    console.log('Client ready')
})

// set global prefix
let prefix = `!`

console.log(process.argv)

client.on('message', async (message) => {
    if (message.author.id === client.user.id) return;
    if (message.content[0] !== prefix) return
    let command = message.content.substring(1)
    switch (command) {
        case 'intro': {
            let questions = await lib.intro_dmProcess(message.author)
            lib.intro_embed(message, questions, `${message.author.username}#${message.author.discriminator}`)
            break
        }
        default:
            message.channel.send('Command Undefined!')
    }
})

module.exports.main = token => {
    client.login(token).then(
        r => console.log(`Token: ${r}`)
    )
}