const Discord = require('discord.js')

module.exports = {
    Message: class Message {
        constructor(originalMessage) {
            this.id = originalMessage.id
            this.content = originalMessage.content
            this.author = {
                'id': originalMessage.author.id,
                'username': originalMessage.author.username,
                'nickname': this.getAuthorNickname(originalMessage, originalMessage.author),
                'object': originalMessage.author
            }
            this.original = originalMessage
        }

        getAuthorNickname(message, user) {
            const member = message.channel.guild.member(user);
            // if user has no nickname in the server return normal discord username
            if (member.nickname === null) return user.username;
            return member.nickname;
        }
    },
    async intro_dmProcess(recipient) {
        try {
            output = {
                name: ``,
                age: ``,
                gender: ``,
                s_orientation: ``,
                hobbies: ``,
                location: ``,
                dm_status: ``,
                about_me: ``
            }
            let questions = [
                {var: 'name', q: 'What is your name?', a: ``, f: 'Name',c: 1},
                {var: 'age', q: 'How old are you?', a: ``, f: 'Age',c: 1},
                {var: 'gender', q: 'What is your gender?', a: ``, f: 'Gender',c: 1},
                {var: 's_orientation', q: 'What is your orientation?', a: ``, f: 'Orientation',c: 1},
                {var: 'hobbies', q: 'What are your hobbies? (3)', a: ``, f: 'Hobbies',c: 3},
                {var: 'location', q: 'Where are you located?', a: ``, f: 'Location',c: 1},
                {var: 'dm_status', q: 'What is your DM status?', a: ``, f: "DM's",c: 1},
                {var: 'about_me', q: 'Tell us something about you', a: ``, f: 'About',c: 1},
            ]
            let stepindex = 0
            while (stepindex < questions.length) {
                question = questions[stepindex]
                let msgtext = ''
                const sentDM = await recipient.send(question['q'])
                let dmChannel = sentDM.channel;
                await dmChannel.awaitMessages(m => true, {max: question['c'], time: 300000, errors: ['time']}).then(collected => {
                    // for (x in collected.array()) {
                    //     entry = collected.array()[x]
                    //     msgtext === '' ? msgtext = entry.content : msgtext = msgtext + '\n' + entry.content
                    // }

                    msgtext = collected.array().join('\n')
                })

                console.log(msgtext)
                question['a'] = msgtext
                stepindex++
            }
            console.log(questions)
            return await questions
        } catch (e) {
            const sentDm = await recipient.send('You took too long. Please start the process over.')
            console.log(e)
        }
    },
    async intro_embed(message, questions, discord_handle) {
        fields = []
        out = {}
        for (x in questions) {
            question = questions[x]
            console.log(question)
            if (question.var === 'name' || question.var === 'about_me') {
                out[question.var] = question.a;
            } else {
                fields.push({
                    'name': question.f,
                    'value': question.a,
                    'inline': true
                })
            }
        }
        const embed = new Discord.MessageEmbed()
            .setTitle(`${out.name} (${discord_handle})`)
            .setDescription(out.about_me)
            .addFields(fields)
        await message.channel.send(embed)
    }
}